/*  
Copyright 2014 Joel Lienhard  (joel@mclien.de  joel@sisam42.de)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// you obviously need to have e copy of adafruits nepixel Library in the according arduino folder

#include <Adafruit_NeoPixel.h>

#define PIN 3
#define UP 9
#define DOWN 12
#define Left 10
#define Right 11

#define matrixx 10
#define matrixy 35
#define fallspeedorg 80
#define debouncevalue 10

int pos[2] = {5, 1};
int bricks[7][4][2] = {{{0, 1}, {-1, 0}, {0, 0}, {1, 0}}, {{-1, 1}, {-1, 0}, {0, 0}, {1, 0}}, {{1, 1}, {-1, 0}, {0, 0}, {1, 0}}, {{-1, 0}, {0, 0}, {0, 1}, {1, 1}}, {{-1, 1}, {0, 1}, {0, 0}, {1, 0}}, {{1, 0}, {1, 1}, {0, 1}, {0, 0}}, {{-1, 0}, {0, 0}, {1, 0}, {2, 0}}};
int colors[7][3] = {{255, 0, 0}, {100, 255, 0}, {0, 0, 255}, {255, 255, 0}, {0, 255, 255}, {255, 100, 0}, {255, 255, 255}};
int matrix[matrixx][matrixy] = {0};
int current[4][2] = {{1, 1}, {-1, 0}, {0, 0}, {1, 0}};
int currentcach[4][2] = {0};
int currentnum = 1;
int truepos[2] = {0,0};
int fallspeed = fallspeedorg;
int fallcount = 0;
int debounce = 0;
int moveable = 0;
int fullrow = 0;
int rowtodelete = 0;
int gameover = 0;
//int score = 0;

Adafruit_NeoPixel strip = Adafruit_NeoPixel(350, PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  strip.begin();
  strip.show();
  pinMode(UP, INPUT);
  pinMode(DOWN, INPUT);
  pinMode(Left, INPUT);
  pinMode(Right, INPUT);
  digitalWrite(UP, HIGH);
  digitalWrite(DOWN, HIGH);
  digitalWrite(Left, HIGH);
  digitalWrite(Right, HIGH);
}

void loop(){
  if(fallcount == fallspeed){
    fallcount = 0;
    down();
  }
  if(digitalRead(DOWN) == LOW and debounce == 0){
    debounce = debouncevalue;
    down();
  }
  if(digitalRead(Right) == LOW and debounce == 0){
    debounce = debouncevalue;
    right();
  }
  if(digitalRead(Left) == LOW and debounce == 0){
    debounce = debouncevalue;
    left();
  }
  if(digitalRead(UP) == LOW and debounce == 0){
    debounce = debouncevalue;
    rotate();
  }
  if(debounce != 0){
    debounce--;
  }
  fallcount++;
  checkrows();
  checkend();
  show();
  delay(1);
}

void checkend(){
  gameover = 0;
  for(int x = 0; x < 10; x++){
    if(matrix[x][1] != 0){
      gameover = 1;
    }
  }
  if(gameover == 1){
    pos[0] = 5;
    pos[1] = 1;
    for(int x = 0; x < 10; x++){
      for(int y = 0; y< 35; y++){
        matrix[x][y] = 0;
      }
    }
    add(random(7));
    for(int x = 0; x < 10; x++){
      for(int y = 0; y< 35; y++){
        matrix[x][y] = 0;
      }
    }
  }
}

void checkrows(){
  for(int y = 0; y < 35; y++){
    fullrow = 1;
    for(int x = 0; x < 10; x++){
      if(matrix[x][y] == 0){
        fullrow = 0;
      }
    }
    if(fullrow == 1){
      for(int row = y; row > 0; row--){
        for(int x = 0; x < 10; x++){
          matrix[x][row] = matrix[x][row-1];
        }
      }
      //score++;
      //fallspeed = fallspeedorg * (0.9*score);
    }
  }
}
    

void down(){
  moveable = 1;
  for(int e = 0; e < 4; e++){
    if(matrix[current[e][0]+pos[0]][current[e][1]+pos[1]+1] != 0){
      moveable = 0;
    }
    if(current[e][1]+pos[1]+1 == 35){
      moveable = 0;
    }
  }
  if(moveable == 1){
    pos[1]++;
  }
  else{
    add(random(7));
  }
}

void right(){
  moveable = 1;
  for(int e = 0; e < 4; e++){
    if(matrix[current[e][0]+pos[0]+1][current[e][1]+pos[1]] != 0){
      moveable = 0;
    }
    if(current[e][0]+pos[0]+1 == 10){
      moveable = 0;
    }
  }
  if(moveable == 1){
    pos[0]++;
  }
}

void left(){
  moveable = 1;
  for(int e = 0; e < 4; e++){
    if(matrix[current[e][0]+pos[0]-1][current[e][1]+pos[1]] != 0){
      moveable = 0;
    }
    if(current[e][0]+pos[0]-1 == -1){
      moveable = 0;
    }
  }
  if(moveable == 1){
    pos[0]--;
  }
}

void rotate(){
  for(int e = 0; e < 4; e++){
    currentcach[e][0] = current[e][0];
    currentcach[e][1] = current[e][1];
  }
  for(int e = 0; e < 4; e++){
    current[e][1] = currentcach[e][0];
    current[e][0] = -currentcach[e][1];
  }
  moveable = 1;
  for(int e = 0; e < 4; e++){
    if(matrix[current[e][0]+pos[0]][current[e][1]+pos[1]] != 0){
      moveable = 0;
    }
    if(current[e][0]+pos[0] < 0){
      moveable = 0;
    }
    if(current[e][0]+pos[0] > 9){
      moveable = 0;
    }
  }
  if(moveable == 0){
    for(int e = 0; e < 4; e++){
      current[e][0] = currentcach[e][0];
      current[e][1] = currentcach[e][1];
    }
  }
}

void add(int b){
  for(int e = 0; e < 4; e++){
    matrix[current[e][0]+pos[0]][current[e][1]+pos[1]] = currentnum + 1;
    current[e][0] = bricks[b][e][0];
    current[e][1] = bricks[b][e][1];
  }
  currentnum = b;
  pos[0] = 5;
  pos[1] = 1;
}

void show(){
  for(int i = 0; i < strip.numPixels(); i++){
    strip.setPixelColor(i, 0, 0, 0);
  }
  for(int x = 0; x < matrixx; x++){
    for(int y = 0; y < matrixy; y ++){
      if(matrix[x][y] != 0){
         if(x%2 == 1){
           strip.setPixelColor((x*matrixy)+y, colors[matrix[x][y]-1][0], colors[matrix[x][y]-1][1], colors[matrix[x][y]-1][2]);
         }
         else{
         strip.setPixelColor((x*matrixy)+(matrixy-y-1), colors[matrix[x][y]-1][0], colors[matrix[x][y]-1][1], colors[matrix[x][y]-1][2]);
        }
      }
    }
  }
  for(int e = 0; e < 4; e++){
    truepos[0] = current[e][0]+pos[0];
    truepos[1] = current[e][1]+pos[1];
    if(truepos[0]%2 == 1){
      strip.setPixelColor((truepos[0]*matrixy)+truepos[1], colors[currentnum][0], colors[currentnum][1], colors[currentnum][2]);
    }
    else{
      strip.setPixelColor((truepos[0]*matrixy)+(matrixy-truepos[1]-1), colors[currentnum][0], colors[currentnum][1], colors[currentnum][2]);
    }
  }
  strip.show();
}

